---
title: ServiceWorkerGlobalScope.skipWaiting()
slug: Web/API/ServiceWorkerGlobalScope/skipWaiting
tags:
  - API
  - Method
  - Reference
  - Service Workers
  - Service worker API
  - ServiceWorker
  - skipWaiting
---
<div>{{APIRef("Service Workers API")}}</div>

<p><span class="seoSummary">The <strong><code>ServiceWorkerGlobalScope.skipWaiting()</code></strong> method of the {{domxref("ServiceWorkerGlobalScope")}} forces the waiting service worker to become the active service worker.</span></p>

<p>Use this method with {{domxref("Clients.claim()")}} to ensure that updates to the underlying service worker take effect immediately for both the current client and all other active clients.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">ServiceWorkerGlobalScope.skipWaiting().then(function() {
  //Do something
});</pre>

<h3 id="Returns">Returns</h3>

<p>A {{jsxref("Promise")}} that immediately resolves with <code>undefined</code>.</p>

<h2 id="Example">Example</h2>

<p>While <code>self.skipWaiting()</code> can be called at any point during the service worker's execution, it will only have an effect if there's a newly installed service worker that might otherwise remain in the <code>waiting</code> state. Therefore, it's common to call <code>self.skipWaiting()</code> from inside of an {{domxref("InstallEvent")}} handler.</p>

<p>The following example causes a newly installed service worker to progress into the <code>activating</code> state, regardless of whether there is already an active service worker.</p>

<pre class="brush: js">self.addEventListener('install', function(event) {
  // The promise that skipWaiting() returns can be safely ignored.
  self.skipWaiting();

  // Perform any other actions required for your
  // service worker to install, potentially inside
  // of event.waitUntil();
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-serviceworkerglobalscope-skipwaiting', 'skipWaiting()')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ServiceWorkerGlobalScope.skipWaiting")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li>{{domxref("Clients.claim()")}}</li>
 <li>{{jsxref("Promise", "Promises")}}</li>
 <li><a href="/en-US/docs/Web/Guide/Performance/Using_web_workers">Using web workers</a></li>
</ul>
